unit uRptWordAlbaranProveedor;

interface

uses
  SysUtils, Classes, AHWord97, IB, IBCustomDataSet, IBDatabase,
  Word2000, uDAInterfaces, uDADataStreamer, uDABin2DataStreamer, uDAClasses,
  uDAScriptingProvider, uDADataTable, uDAMemDataTable;

type
  TRptWordAlbaranProveedor = class(TDataModule)
    DABin2DataStreamer: TDABin2DataStreamer;
    tbl_Cabecera: TDAMemDataTable;
    tbl_Detalles: TDAMemDataTable;
    tbl_Empresa: TDAMemDataTable;
    schReport: TDASchema;
    DataDictionary: TDADataDictionary;
    procedure DataModuleCreate(Sender: TObject);
  private
    FConnection: IDAConnection;
    FPlantilla : string;
    FWordApp : TWordApp;
    FDocumento : TWordDoc;
    FCodigoAlbaran : string;
    FNombreFichero : String;

    function Generar : Boolean;
    function RellenarDatosAlbaran : Boolean;
    function RellenarDatosDetalle : Boolean;
    procedure _GenerarAlbaran(const AID: String);
  public
    ImprimirPrecio : Boolean;
    ImprimirRefProveedor : Boolean;
    function Exportar(Codigo, Fichero : String): Boolean;
    constructor Create (AOwner : TComponent); override;
    destructor Destroy; override;
  end;

implementation

{ TRptWordAlbaranProveedor }

{$R *.dfm}

uses
  Windows, Variants, Dialogs, uDataModuleServer, uStringsUtils, uSistemaFunc,
  srvEmpresas_Impl, uROTypes, uROClasses;

const
  rptInforme = 'AlbaranProveedor.rdx';  
  
constructor TRptWordAlbaranProveedor.Create(AOwner: TComponent);
begin
  inherited;
  ImprimirPrecio := False;
  ImprimirRefProveedor := False;
  FDocumento := NIL;
end;

destructor TRptWordAlbaranProveedor.Destroy;
begin
  if FDocumento <> NIL then
    FDocumento.Free;
  FDocumento := NIL;
  inherited;
end;

function TRptWordAlbaranProveedor.Exportar(Codigo, Fichero: String): Boolean;
begin
  if EsCadenaVacia(Fichero) then
  begin
    Result := False;
    raise Exception.Create('Falta indicar el fichero donde se exportará el listado.');
  end;

  FNombreFichero := Fichero;
  FCodigoAlbaran := Codigo;
  _GenerarAlbaran(Codigo);
  Result := True;
end;

procedure TRptWordAlbaranProveedor.DataModuleCreate(Sender: TObject);
begin
  schReport.ConnectionManager := dmServer.ConnectionManager;
  FConnection := dmServer.DarNuevaConexion;
end;

function TRptWordAlbaranProveedor.Generar : Boolean;
begin
  FWordApp := TWordApp.Create (False, False);
  with FWordApp do
  begin
    Visible := False;
    ScreenUpdating := False;
  end;

  FDocumento := TWordDoc.CreateNewDoc(FWordApp, FPlantilla);
  FWordApp.SaveActiveDocAs(FNombreFichero);
  try
    if not RellenarDatosAlbaran then
      RaiseError('Se producido un error al generar la cabecera en MS Word.');

    if not RellenarDatosDetalle then
      RaiseError('Se producido un error al generar el informe en MS Word.');

    FWordApp.CloseApp(wdSaveChanges);
    Result := True;
  finally
    FDocumento := NIL;
    FWordApp := NIL;
  end;
end;


function TRptWordAlbaranProveedor.RellenarDatosDetalle : Boolean;
var
  numRows, numCols, mergesplit : OleVariant;
  MaxCols, iRowCount : Integer;
  ACantidad: String;
  AIndice: Integer;
  AText : String;  
begin
  iRowCount := 2;
  numrows := 2;
  numcols := 1;
  mergeSplit := False;
  MaxCols := 12;

  with FDocumento.Document.Tables.Item(1), tbl_Detalles do
  begin
    tbl_Detalles.First;
    while not tbl_Detalles.EOF do
    begin
        Rows.Item (iRowCount).Cells.Split (numRows, numCols, mergesplit);

        if ImprimirRefProveedor then
          Cell(iRowCount, 1).Range.Text := FieldByName('REFERENCIA_PROVEEDOR').AsString;

        Cell(iRowCount, 2).Range.Text := FieldByName('REFERENCIA_FABRICANTE').AsString;
        Cell(iRowCount, 3).Range.Text := FieldByName('CONCEPTO').AsString;

        ACantidad := FloatToStr(FieldByName('CANTIDAD').AsFloat);
        AIndice := Pos(',', ACantidad);
        if AIndice > 0 then
          AText := FormatFloat('#,0.00', FieldByName('CANTIDAD').AsFloat)
        else
          AText := FormatFloat('#,0.##', FieldByName('CANTIDAD').AsFloat);

        Cell(iRowCount, 4).Range.Text := AText + ' ' + FieldByName('UNIDAD_MEDIDA').AsString;

        if ImprimirPrecio
        and (FieldByName('IMPORTE_UNIDAD').AsFloat <> 0) then
          Cell(iRowCount, 5).Range.Text := FormatFloat(DISPLAY_EUROS2, FieldByName('IMPORTE_UNIDAD').AsFloat)
        else
          Cell(iRowCount, 5).Range.Text := '';

        if ImprimirPrecio
        and (FieldByName('IMPORTE_TOTAL').AsFloat <> 0) then
          Cell(iRowCount, 6).Range.Text := FormatFloat(DISPLAY_EUROS2, FieldByName('IMPORTE_TOTAL').AsFloat)
        else
          Cell(iRowCount, 6).Range.Text := '';

        Next;
        Inc (iRowCount);
    end;

    Rows.Item(iRowCount).Delete;

    {while iRowCount <= MaxCols do
    begin
        Rows.Item (iRowCount).Cells.Split (numRows, numCols, mergesplit);
        inc (iRowCount);
    end;}
  end;
  Result := True;
end;

function TRptWordAlbaranProveedor.RellenarDatosAlbaran : Boolean;
var
  DireccionEntrega : String;
//  LinkToFile, SaveWithDocument, _Range : OleVariant;
//  Imagen : InlineShape;

begin

  //PARA DIBUJAR EL LOGOTIPO MULTIEMPRESA
  {if (EmpresaActiva.Logotipo <> Nil) then
  begin
    //Activamos cabecera
    FWordApp.Application.ActiveWindow.ActivePane.View.SeekView := wdSeekCurrentPageHeader;
    LinkToFile := False;
    SaveWithDocument := True;
    _Range := EmptyParam;
    FicheroTemporal := DarFicheroTemporal;
    EmpresaActiva.Logotipo.SaveToFile (FicheroTemporal);
    Imagen := FWordApp.Application.ActiveWindow.ActivePane.Selection.InlineShapes.AddPicture(ficherotemporal, LinkToFile, SaveWithDocument, _Range);

    //Formateamos imagen
    if ((Imagen.Get_Width > ANCHO_LOGO_INF)) then
    begin
      Imagen.Set_Height(((ANCHO_LOGO_INF * Imagen.Get_Height) /Imagen.Get_Width));
      Imagen.Set_Width(ANCHO_LOGO_INF);
    end;
  end;}

  with FDocumento, tbl_Cabecera do
  begin
    if FieldByName('TIPO').AsString = 'D' then 
      ReplaceBookmark('TituloDocumento', 'ORDEN DE DEVOLUCIÓN');    


    ReplaceBookmark('CodigoAlbaran', FieldByName('REFERENCIA').AsString);
    ReplaceBookmark('FechaAlbaran', FieldByName('FECHA_ALBARAN').AsString);

    // En la dirección mostrar aquellos campos que estén rellenos.
    DireccionEntrega := '';
    if not EsCadenaVacia(FieldByName('CALLE').AsString) then
      DireccionEntrega := DireccionEntrega + FieldByName('CALLE').AsString;
    if not EsCadenaVacia(FieldByName('CODIGO_POSTAL').AsString) then
      DireccionEntrega := DireccionEntrega + ', ' + FieldByName('CODIGO_POSTAL').AsString;
    if not EsCadenaVacia(FieldByName('POBLACION').AsString) then
      DireccionEntrega := DireccionEntrega + ', ' + FieldByName('POBLACION').AsString;
    if not EsCadenaVacia(FieldByName('PROVINCIA').AsString) then
      DireccionEntrega := DireccionEntrega + ', ' + FieldByName('PROVINCIA').AsString;
    ReplaceBookmark('LugarEntrega', DireccionEntrega);

    {    ReplaceBookmark('LugarEntrega', FieldByName('CALLEALMACEN').AsString + ' ' +
      FieldByName('NUMEROALMACEN').AsString + ', '  + FieldByName('PISOALMACEN').AsString + ', ' +
      FieldByName('CODIGOPOSTALALMACEN').AsString + ' ' + FieldByName('POBLACIONALMACEN').AsString + ', ' + FieldByName('PROVINCIAALMACEN').AsString);}

//    ReplaceBookmark('PersonaEntrega', FieldByName('ENTREGAR_A').AsString);

{    if FieldByName('FECHA_ENTREGA').IsNull then
       ReplaceBookmark('FechaEntrega', '')
    else
       ReplaceBookmark('FechaEntrega', 'FECHA DE ENTREGA PREVISTA: ' + FieldByName('FECHA_ENTREGA').AsString);}

	ReplaceBookmark('NombreProveedor', FieldByName('NOMBRE').AsString);
    ReplaceBookmark('FaxProveedor', FieldByName('FAX').AsString);
    ReplaceBookmark('PersonaContactoProveedor', FieldByName('PERSONA_CONTACTO').AsString);
    ReplaceBookmark('CodigoClienteProveedor', FieldByName('CODIGO_CLIENTE').AsString);

    if ImprimirPrecio then
      ReplaceBookmark('ImporteTotal', FormatFloat(DISPLAY_EUROS2, FieldByName('IMPORTE_TOTAL').AsFloat))
    else
      ReplaceBookmark('ImporteTotal', '');

    ReplaceBookmark('NotasAlbaran', FieldByName('OBSERVACIONES').AsString);

    ReplaceBookmark('NombreEmpresa', tbl_Empresa.FieldByName('NOMBRE').AsString);
    ReplaceBookmark('NombreEmpresa2', tbl_Empresa.FieldByName('NOMBRE').AsString);
    ReplaceBookmark('CifEmpresa', tbl_Empresa.FieldByName('NIF_CIF').AsString);
    ReplaceBookmark('DireccionEmpresa',
      Format('%s. %s %s', [tbl_Empresa.FieldByName('CALLE').AsString,
      tbl_Empresa.FieldByName('CODIGO_POSTAL').AsString, tbl_Empresa.FieldByName('POBLACION').AsString]));
    ReplaceBookmark('TelefonoEmpresa', tbl_Empresa.FieldByName('TELEFONO_1').AsString);
    ReplaceBookmark('FaxEmpresa', tbl_Empresa.FieldByName('FAX').AsString);
    ReplaceBookmark('CorreoEmpresa', tbl_Empresa.FieldByName('EMAIL_1').AsString);
  end;
  Result := True;  
end;

procedure TRptWordAlbaranProveedor._GenerarAlbaran(const AID: String);
var
  ACopiaPlantilla : String;
begin
  FConnection.BeginTransaction; //<--- Creo que no va a hacer falta. "PUES SI ES NECESARIO"
  try
    tbl_Cabecera.ParamByName('ID').AsString := AID;
    tbl_Detalles.ParamByName('ID_ALBARAN').AsString := AID;

    tbl_Cabecera.Active := True;
    tbl_Detalles.Active := True;

    FPlantilla := DarRutaInformes + tbl_Cabecera.FieldByName('ID_EMPRESA').AsString + '\' + rptInforme;
    FCodigoAlbaran := AID;

    if RecuperarEmpresa(tbl_Cabecera.FieldByName('ID_EMPRESA').AsInteger, tbl_Empresa) then
    begin
      ACopiaPlantilla := DarFicheroTemporal;
      CopiarFichero(FPlantilla, ACopiaPlantilla);
      FPlantilla := ACopiaPlantilla;
      try
        Generar;
      finally
        SysUtils.DeleteFile(ACopiaPlantilla);
      end;
    end;
  finally
    FConnection.RollbackTransaction; //<--- Creo que no va a hacer falta. "PUES SI ES NECESARIO"
  end;
end;


end.
